'DUNEDIT , a DUNE 2 EDITOR WRITTEN IN QUICKBASIC BY STEFAN HENDRIKS
'Any comments? suggestions, feedback ??, send me an e-mail.
'stefan@flash.a2000.nl
'Compile in DOS MODE!
'VERSION 1.24
'SITE: PEOPLE.A2000.NL/RHENDRIK/DUNEII.HTM

'Ok i have commented this source file at version 1.24 so everybody
'can understand atleast SOME things
DECLARE SUB toetsen ()          'Will draw a dialog,window with the function keys
DECLARE SUB fremensub ()        'Loads FREMEN stuff from a dune 2 file
DECLARE SUB introductie ()      'Intro screen
DECLARE SUB mercenarysub ()     'Loads MERCENARY stuff
DECLARE SUB herstart ()         'Restarts dunedit, clears all variables etc
DECLARE SUB bewaarspelers ()    'Saves player in a modified scenario
DECLARE SUB zettoetsen ()       'Prints below on the screen that F1 is TOETSEN
DECLARE SUB tekenschaal ()      'Draws mapscale
DECLARE SUB plaatsalles ()      'Places the buildings,units
DECLARE SUB reinfsub ()         'Reinforcement SUB
DECLARE SUB choambalk ()        'CHOAM sub
DECLARE SUB delprocedure ()     'Del stuff
DECLARE SUB lijstplaatjes ()    'Prints the list of available pictures
DECLARE SUB mapopenen (B$)      'Loads map... SEEDMAP!
DECLARE SUB acties ()           'Draws actions
DECLARE SUB basicsub ()         'Loads basic
DECLARE SUB Sardaukarsub ()     'Loads SARDAUKAR  stuff
DECLARE SUB Atreidessub ()      'Loads ATREIDES stuff
DECLARE SUB Ordossub ()         'Loads ORDOS stuff
DECLARE SUB infobar ()          'Info bar
DECLARE SUB harkonnensub ()     'Loads HARKONNEN stuff
DECLARE SUB mapsub ()           'Loads map from a INI file
DECLARE SUB gebouwsub ()        'Loads BUILDINGS section from a INI file
DECLARE SUB unitssub ()         'The same, except it is for the UNITS
DECLARE SUB lijstvanunits ()    'Prints available list of units
DECLARE SUB bestandopenen (B$)  'Opens a INI file
DECLARE SUB lijnen ()           'Draws the interface
DECLARE SUB wiszijkant ()       'Deletes the bar
DECLARE SUB huizen ()           'Prints all available houses
DECLARE SUB lijstGebouwen ()    'Prints list of available buildings
DECLARE SUB scherm ()           'Draws the interface
DECLARE SUB wisblokje (x, y)    'Delets cursor from position x,y
DECLARE SUB nrsub (nr, kleur)   'Defines color
'OK
'A lot of variables are in the common lines....
COMMON SHARED gevonden, gebouwgevonden, gebouwen, units, bericht$, berichtteller, orcredits, hacredits, sacredits, atcredits, geenmapladen
COMMON SHARED ormu, hamu, samu, atmu, plaatje$(), orsp$, hasp$, sasp$, atsp$
COMMON SHARED schermtekening, tpx, tpy, keer, keer1, fieldaan, spelernr, spelercredits, atreidesgeb, harkonnengeb, ordosgeb, sardaukargeb, spelercr$
COMMON SHARED animatie, geregd, schaal, proc, unitx, unity, gebouwx, gebouwy, gebouwhouse$
COMMON SHARED factora, factoro, factors, factorh, mina, mins, mino, minh, reinfkeer, bss$, gebouwlaatstneergezet, unitlaatstneergezet, fieldlaatstneergezet, bloomlaatstneergezet, minf, factorf
COMMON SHARED eenleesregel, boven$, trks$, qads$, tnks$, lncs$, stks$, hrvs$, mcvs$, cars$, trs1$, trs2$, devs$, dvas$, infs$, sols$, sons$
COMMON SHARED reins, aantalreins, reingeladen, reinfregel$, lpy, lpx, tacticalpos$, gens, gensoort$, gencell$, eenkeertjefield, eenkeertjebloom
COMMON SHARED fields, blooms, bewaarfield, bewaarbloom, psx1, psy1, psx2, psy2, mercenarygeb, minm, factorm, reinregels, reinfnr, orc$, verren, quota$, q$, hac$, frc$, mec$, atc$, sac$, fremengeb

SCREEN 13               'We use 320X200X256 for a intro picture
COLOR 7: PRINT "Loading.. Please wait.."
DIM PAL(255) AS LONG
OPEN "I", #1, "dunedit.pal"
FOR I = 0 TO 255
        INPUT #1, PAL(I)
NEXT
CLOSE #1
PALETTE USING PAL(0)
BLOAD "dunedit.pic"
WHILE INKEY$ = "": WEND

SCREEN 12: WIDTH 80, 60: COLOR 7        'NOW we enter dunedit with 640X400X16
'Variables are shared...
DIM SHARED defaulthouse$(10)
DIM SHARED defaultactie$(10)
DIM SHARED plaatjenr(30)
DIM SHARED genhouse$(500)
DIM SHARED unitsoort$(50)
DIM SHARED gebouwsoort$(100)
DIM SHARED gebouwx(100)
DIM SHARED gebouwy(100)
DIM SHARED unitx(100)
DIM SHARED unity(100)
DIM SHARED gebouwhouse$(100)
DIM SHARED unithouse$(100)
DIM SHARED actie$(100)
DIM SHARED num1$(100)
DIM SHARED num$(100)
DIM SHARED cell$(100)
DIM SHARED cellu$(100)
DIM reinr$(30)
DIM huisrn$(30)
DIM rnunit$(30)
DIM waar$(30)
DIM tu$(30)
DIM SHARED plaatje$(3)
DIM SHARED reinfregel$(50)
DIM SHARED gensoort$(500)
DIM SHARED gencell$(500)
DIM SHARED fieldcell$(50)
DIM SHARED bloomcell$(50)
fieldregel$ = "Field=": bloomregel$ = "Bloom=": geenmapladen = 1: aantalreins = 1
gens = 0: reins = 1: kleur = 9: gebouwen = 0: units = 0
verren = 1: foutgehad = 0

ON ERROR GOTO fouten    'An error ocurred? goto FOUTEN
OPEN "DUNEDIT.DAT" FOR INPUT AS #1      'Loads DATA
INPUT #1, schermtekening, animatie, geregd, slainfo
FOR I = 1 TO 6
INPUT #1, defaulthouse$(I)
NEXT I
FOR I = 1 TO 5
INPUT #1, defaultactie$(I)
NEXT I
CLOSE #1
nrdh = 1: nrda = 1: x = 1: y = 0: cux = 0: cuy = 0: cell = 0
CLS
introductie             'INTRO SCREEN
scherm                  'INTERFACE
berichtteller = 299: berichtnr = 0: eenkeer = 0: gens = 0
opnieuw:
zettoetsen              'PRINTS TOETSEN
'OK from here it is a lot of garbage. I only know this works.
'The last time i saw the code was a long time.
'The update 1.24 will probably the latest, So i can create new one
'in 256 Colors. And MAYBE a svga version when everything goes fine.

DO
k$ = INKEY$
LINE (x, y)-(x + 6, y + 6), 15, B
aantalgebouwen = gebouwen - 1
IF gebouwen > 0 THEN
FOR I = 0 TO aantalgebouwen
IF cux = gebouwx(I) AND cuy = gebouwy(I) THEN
IF gebouwsoort$(I) = "Const Yard" THEN bericht$ = "Construction Yard              ": berichtteller = 0
IF gebouwsoort$(I) = "Spice Silo" THEN bericht$ = "Spice Silo                     ": berichtteller = 0
IF gebouwsoort$(I) = "Windtrap" THEN bericht$ = "Windtrap                       ": berichtteller = 0
IF gebouwsoort$(I) = "WOR" THEN bericht$ = "WOR                            ": berichtteller = 0
IF gebouwsoort$(I) = "Barracks" THEN bericht$ = "Barracks                       ": berichtteller = 0
IF gebouwsoort$(I) = "Light Fctry" THEN bericht$ = "Light Factory                  ": berichtteller = 0
IF gebouwsoort$(I) = "Heavy Fctry" THEN bericht$ = "Heavy Factory                  ": berichtteller = 0
IF gebouwsoort$(I) = "Palace" THEN bericht$ = "Palace                         ": berichtteller = 0
IF gebouwsoort$(I) = "R-Turret" THEN bericht$ = "Rocket Turret                  ": berichtteller = 0
IF gebouwsoort$(I) = "Turret" THEN bericht$ = "Turret                         ": berichtteller = 0
IF gebouwsoort$(I) = "IX" THEN bericht$ = "House of IX                    ": berichtteller = 0
IF gebouwsoort$(I) = "Repair" THEN bericht$ = "Repair station                 ": berichtteller = 0
IF gebouwsoort$(I) = "Refinery" THEN bericht$ = "Spice Refinery                 ": berichtteller = 0
IF gebouwsoort$(I) = "Outpost" THEN bericht$ = "Outpost                        ": berichtteller = 0
IF gebouwsoort$(I) = "Hi-Tech" THEN bericht$ = "High Tech (Carials)            ": berichtteller = 0
IF gebouwsoort$(I) = "Starport" THEN bericht$ = "Starport                       ": berichtteller = 0
END IF

NEXT I
END IF

aantalunits = units - 1
IF units > 0 THEN
FOR I = 0 TO aantalunits
IF cux = unitx(I) AND cuy = unity(I) THEN
IF unitsoort$(I) = "Soldier" THEN bericht$ = "Soldier                        ": berichtteller = 0
IF unitsoort$(I) = "Infantry" THEN bericht$ = "Infantry (3 soldiers)          ": berichtteller = 0
IF unitsoort$(I) = "Trooper" THEN bericht$ = "Bazooka Soldier                ": berichtteller = 0
IF unitsoort$(I) = "Troopers" THEN bericht$ = "Bazooka Soldiers (3 soldiers)  ": berichtteller = 0
IF unitsoort$(I) = "Quad" THEN bericht$ = "Quad                           ": berichtteller = 0
IF unitsoort$(I) = "Trike" THEN bericht$ = "Trike                          ": berichtteller = 0
IF unitsoort$(I) = "Tank" THEN bericht$ = "Tank                           ": berichtteller = 0
IF unitsoort$(I) = "Siege Tank" THEN bericht$ = "Siege Tank                     ": berichtteller = 0
IF unitsoort$(I) = "Devastator" THEN bericht$ = "Devastator                     ": berichtteller = 0
IF unitsoort$(I) = "Deviator" THEN bericht$ = "Deviator                       ": berichtteller = 0
IF unitsoort$(I) = "Launcher" THEN bericht$ = "Rocket Launcher                ": berichtteller = 0
IF unitsoort$(I) = "Raider Trike" THEN bericht$ = "Raider Trike                   ": berichtteller = 0
IF unitsoort$(I) = "Sonic Tank" THEN bericht$ = "Sonic Tank                     ": berichtteller = 0
IF unitsoort$(I) = "Sandworm" THEN bericht$ = "Sand worm                      ": berichtteller = 0
IF unitsoort$(I) = "CarryAll" THEN bericht$ = "CarryAll                       ": berichtteller = 0
IF unitsoort$(I) = "Harvester" THEN bericht$ = "Spice Harvester                ": berichtteller = 0
IF unitsoort$(I) = "MCV" THEN bericht$ = "Mobile Construction Vehicle.   ": berichtteller = 0
END IF
NEXT I
END IF

IF k$ = CHR$(0) + "M" THEN wisblokje x, y: x = x + 6: cux = cux + 1: cell = cell + 1
IF k$ = CHR$(0) + "H" THEN wisblokje x, y: y = y - 6: cuy = cuy - 1: cell = cell - 64
IF k$ = CHR$(0) + "K" THEN wisblokje x, y: x = x - 6: cux = cux - 1: cell = cell - 1
IF k$ = CHR$(0) + "P" THEN wisblokje x, y: y = y + 6: cuy = cuy + 1: cell = cell + 64

'More keys
IF k$ = CHR$(0) + "<" THEN GOTO bewaarsnel
IF k$ = CHR$(0) + ";" THEN toetsen
IF k$ = CHR$(0) + "=" THEN GOTO openensnel

'Controle veld
IF y < 0 THEN y = 0: cuy = 0: cell = cell + 64
IF y > 378 THEN y = 378: cuy = 63: cell = cell - 64
IF x < 1 THEN x = 1: cux = 0: cell = cell + 1
IF x > 379 THEN x = 379: cux = 63: cell = cell - 1

COLOR 14: LOCATE 1, 50: PRINT "Dune II Map Editor 'DUNEDIT'"
COLOR 7: LOCATE 3, 50: PRINT "XPos     :"; cux
LOCATE 4, 50: PRINT "YPos     :"; cuy
LOCATE 5, 50: PRINT "Cell     :"; cell
LOCATE 3, 65: PRINT "Structrs:"; gebouwen
LOCATE 4, 65: PRINT "Units   :"; units
LOCATE 7, 50: PRINT "-------------------------------"
COLOR 15: LOCATE 8, 50: PRINT bericht$: COLOR 7
LOCATE 9, 50: PRINT "-------------------------------"

IF verren = 1 THEN
COLOR 10
LOCATE 52, 1: PRINT "H.Default House :             "
LOCATE 53, 1: PRINT "A.Default Action:            "
LOCATE 52, 18: PRINT defaulthouse$(nrdh)
LOCATE 53, 18: PRINT defaultactie$(nrda)
COLOR 7
LOCATE 52, 62: PRINT "FILE:"; : COLOR 15: PRINT UCASE$(bewaarbestand$)
COLOR 7
LOCATE 53, 62: PRINT "SEED:"; : COLOR 15: PRINT UCASE$(bss$)
verren = 0
END IF
COLOR 7
berichtteller = berichtteller + 1
IF k$ = "A" OR k$ = "a" THEN nrda = nrda + 1: k$ = "": verren = 1
IF nrda > 5 THEN nrda = 1
IF k$ = "H" OR k$ = "h" THEN nrdh = nrdh + 1: k$ = "": verren = 1
IF nrdh > 6 THEN nrdh = 1

IF berichtteller = 300 THEN
bericht$ = "                               "

IF berichtnr = 0 THEN bericht$ = "DUNE II MAP EDITOR VERSION 1.24"
IF berichtnr = 1 THEN bericht$ = "Press Space to place somthing. "
IF berichtnr = 2 THEN bericht$ = "Questions ? Send a E-MAIL.     "
IF berichtnr = 3 THEN bericht$ = "     stefan@flash.a2000.nl     "
IF berichtnr = 4 THEN bericht$ = "Programmed by: Stefan Hendriks "
IF berichtnr > 4 THEN berichtnr = 0
berichtnr = berichtnr + 1
berichtteller = 0
END IF

'Powerberekeningen
IF factora > 0 THEN pa = INT(mina / factora)
IF factoro > 0 THEN po = INT(mino / factoro)
IF factorh > 0 THEN ph = INT(minh / factorh)
IF factors > 0 THEN ps = INT(mins / factors)
IF factorm > 0 THEN pm = INT(minm / factorm)
IF factorf > 0 THEN pf = INT(minf / factorf)

IF k$ = " " THEN
wiszijkant
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF

aantalunits = units - 1
IF units > 0 THEN
FOR I = 0 TO aantalunits

IF cux = unitx(I) AND cuy = unity(I) THEN
wiszijkant
LOCATE 12, 53: PRINT "UNIT INFO"
LOCATE 14, 53: PRINT "X-Position  :"; unitx(I)
LOCATE 15, 53: PRINT "Y-Position  :"; unity(I)
LOCATE 16, 53: PRINT "Type        :"; unitsoort$(I)
LOCATE 17, 53: PRINT "Belongs to  :"; unithouse$(I)
LOCATE 18, 53: PRINT "Action      :"; actie$(I)
k$ = ""
GOTO opnieuw
END IF

NEXT I
END IF

aantalgebouwen = gebouwen - 1
IF gebouwen > 0 THEN
FOR I = 0 TO aantalgebouwen

IF cux = gebouwx(I) AND cuy = gebouwy(I) THEN
wiszijkant
LOCATE 12, 53: PRINT "BUILDING INFO"
LOCATE 14, 53: PRINT "X-Position :"; gebouwx(I)
LOCATE 15, 53: PRINT "Y-Position :"; gebouwy(I)
LOCATE 16, 53: PRINT "Type       :"; gebouwsoort$(I)
LOCATE 17, 53: PRINT "Belongs to :"; gebouwhouse$(I)

 
IF gebouwsoort$(I) = "Const Yard" THEN
COLOR 10: LOCATE 19, 53: PRINT "House Information:": COLOR 7
IF gebouwhouse$(I) = "Atreides" THEN blalala$ = atc$
IF gebouwhouse$(I) = "Harkonnen" THEN blalala$ = hac$
IF gebouwhouse$(I) = "Sardaukar" THEN blalala$ = sac$
IF gebouwhouse$(I) = "Ordos" THEN blalala$ = orc$
IF gebouwhouse$(I) = "Mercenary" THEN blalala$ = mec$
IF gebouwhouse$(I) = "Fremen" THEN blalala$ = frc$
LOCATE 21, 53: PRINT "Starting Credits:"; blalala$
END IF

IF gebouwsoort$(I) = "Windtrap" THEN
LOCATE 19, 53: PRINT "Power Info"
LOCATE 21, 53: PRINT "Power Out= 100"
IF gebouwhouse$(I) = "Atreides" THEN pp = pa
IF gebouwhouse$(I) = "Ordos" THEN pp = po
IF gebouwhouse$(I) = "Harkonnen" THEN pp = ph
IF gebouwhouse$(I) = "Sardaukar" THEN pp = ps
IF gebouwhouse$(I) = "Mercenary" THEN pp = pm
IF gebouwhouse$(I) = "Fremen" THEN pp = pf
LOCATE 22, 53: PRINT "Power Needed="; pp
END IF
k$ = ""
GOTO opnieuw
END IF

NEXT I
END IF

LOCATE 10, 53: PRINT "Place :"
LOCATE 11, 53: PRINT "1. Building"
LOCATE 12, 53: PRINT "2. Unit"
LOCATE 13, 50: INPUT "Other figure is Back, NR:", nr
IF nr < 1 OR nr > 2 THEN k$ = "": wiszijkant: GOTO opnieuw
   
IF nr = 2 THEN
        unitx(units) = cux: unity(units) = cuy
        LOCATE 16, 53: PRINT "Enter Type NR   "
lijstvanunits
      LOCATE 50, 54
      COLOR 14: LOCATE 35, 53: INPUT "NR:", nr: COLOR 7
      IF nr < 0 OR nr > 16 THEN k$ = "": wiszijkant: nr = 0: GOTO opnieuw
       
     
      IF nr = 0 THEN unitsoort$(units) = "Sandworm"
      IF nr = 1 THEN unitsoort$(units) = "Soldier"
      IF nr = 2 THEN unitsoort$(units) = "Infantry"
      IF nr = 3 THEN unitsoort$(units) = "Trike"
      IF nr = 4 THEN unitsoort$(units) = "Raider Trike"
      IF nr = 5 THEN unitsoort$(units) = "Quad"
      IF nr = 6 THEN unitsoort$(units) = "Trooper"
      IF nr = 7 THEN unitsoort$(units) = "Troopers"
      IF nr = 8 THEN unitsoort$(units) = "Tank"
      IF nr = 9 THEN unitsoort$(units) = "Launcher"
      IF nr = 10 THEN unitsoort$(units) = "Siege Tank"
      IF nr = 11 THEN unitsoort$(units) = "Deviator"
      IF nr = 12 THEN unitsoort$(units) = "Sonic Tank"
      IF nr = 13 THEN unitsoort$(units) = "Devastator"
      IF nr = 14 THEN unitsoort$(units) = "Harvester"
      IF nr = 15 THEN unitsoort$(units) = "CarryAll"
      IF nr = 16 THEN unitsoort$(units) = "MCV"
      units$ = STR$(units)
      units$ = RIGHT$(units$, LEN(units$) - 1)
      cellu$(units) = STR$(cell)
      cellu$(units) = RIGHT$(cellu$(units), LEN(cellu$(units)) - 1)
     
      IF defaulthouse$(nrdh) = "Atreides" THEN kleur = 1: atreidesgeb = 1
      IF defaulthouse$(nrdh) = "Ordos" THEN kleur = 2: ordosgeb = 1
      IF defaulthouse$(nrdh) = "Harkonnen" THEN kleur = 4: harkonnengeb = 1
      IF defaulthouse$(nrdh) = "Sardaukar" THEN kleur = 5: sardaukargeb = 1
      IF defaulthouse$(nrdh) = "Mercenary" THEN kleur = 0: mercenarygeb = 1
      IF defaulthouse$(nrdh) = "Fremen" THEN kleur = 15: fremengeb = 1
      unithouse$(units) = defaulthouse$(nrdh)

nog:
       actie$(units) = defaultactie$(nrda)
      IF nr = 0 THEN unithouse$(units) = "Fremen": kleur = 15
     
      IF units < 10 AND units > -1 THEN num$(units) = "00" + units$
      IF units < 100 AND units > 9 THEN num$(units) = "0" + units$

      xpos = x: ypos = y
      LINE (xpos, ypos)-(xpos + 6, ypos + 6), kleur, BF
      units = units + 1: k$ = "": nr = 0
      wiszijkant
      unitlaatstneergezet = 1: gebouwlaatstneergezet = 0: fieldlaatstneergezet = 0: bloomlaatstneergezet = 0
      GOTO opnieuw
    END IF

IF nr = 1 THEN
lijstGebouwen
gebouwx(gebouwen) = cux
gebouwy(gebouwen) = cuy
nr = 0
COLOR 14: LOCATE 35, 53: INPUT "NR:", nr: COLOR 7

IF nr < 1 OR nr > 16 THEN wiszijkant: k$ = "": GOTO opnieuw
 
      IF nr = 1 THEN gebouwsoort$(gebouwen) = "Const Yard"
      IF nr = 2 THEN gebouwsoort$(gebouwen) = "Refinery"
      IF nr = 3 THEN gebouwsoort$(gebouwen) = "Spice Silo"
      IF nr = 4 THEN gebouwsoort$(gebouwen) = "Windtrap"
      IF nr = 5 THEN gebouwsoort$(gebouwen) = "Barracks"
      IF nr = 6 THEN gebouwsoort$(gebouwen) = "Outpost"
      IF nr = 7 THEN gebouwsoort$(gebouwen) = "WOR"
      IF nr = 8 THEN gebouwsoort$(gebouwen) = "Light Fctry"
      IF nr = 9 THEN gebouwsoort$(gebouwen) = "Heavy Fctry"
      IF nr = 10 THEN gebouwsoort$(gebouwen) = "Turret"
      IF nr = 11 THEN gebouwsoort$(gebouwen) = "Hi-Tech"
      IF nr = 12 THEN gebouwsoort$(gebouwen) = "Repair"
      IF nr = 13 THEN gebouwsoort$(gebouwen) = "R-Turret"
      IF nr = 14 THEN gebouwsoort$(gebouwen) = "IX"
      IF nr = 15 THEN gebouwsoort$(gebouwen) = "Palace"
      IF nr = 16 THEN gebouwsoort$(gebouwen) = "Starport"

      IF defaulthouse$(nrdh) = "Atreides" THEN kleur = 1: atreidesgeb = 1
      IF defaulthouse$(nrdh) = "Ordos" THEN kleur = 2: ordosgeb = 1
      IF defaulthouse$(nrdh) = "Harkonnen" THEN kleur = 4: harkonnengeb = 1
      IF defaulthouse$(nrdh) = "Sardaukar" THEN kleur = 5: sardaukargeb = 1
      IF defaulthouse$(nrdh) = "Mercenary" THEN kleur = 0: mercenarygeb = 1
      IF defaulthouse$(nrdh) = "Fremen" THEN kleur = 15: fremengeb = 1
      gebouwhouse$(gebouwen) = defaulthouse$(nrdh)

IF gebouwsoort$(gebouwen) = "Windtrap" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN factoro = factoro + 1
IF gebouwhouse$(gebouwen) = "Atreides" THEN factora = factora + 1
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN factors = factors + 1
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN factorh = factorh + 1
IF gebouwhouse$(gebouwen) = "Mercenary" THEN factorm = factorm + 1
IF gebouwhouse$(gebouwen) = "Fremen" THEN factorf = factorf + 1
END IF

IF gebouwsoort$(gebouwen) = "Barracks" OR gebouwsoort$(gebouwen) = "Light Fctry" OR gebouwsoort$(gebouwen) = "Repair" OR gebouwsoort$(gebouwen) = "WOR" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 20
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 20
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 20
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 20
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 20
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 20
END IF

IF gebouwsoort$(gebouwen) = "Heavy Fctry" OR gebouwsoort$(gebouwen) = "Hi-Tech" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 35
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 35
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 35
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 35
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 35
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 35
END IF

IF gebouwsoort$(gebouwen) = "Palace" OR gebouwsoort$(gebouwen) = "Starport" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 80
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 80
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 80
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 80
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 80
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 80
END IF

IF gebouwsoort$(gebouwen) = "Outpost" OR gebouwsoort$(gebouwen) = "Refinery" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 30
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 30
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 30
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 30
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 30
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 30
END IF

IF gebouwsoort$(gebouwen) = "IX" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 40
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 40
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 40
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 40
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 40
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 40
END IF

IF gebouwsoort$(gebouwen) = "R-Turret" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 25
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 25
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 25
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 25
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 25
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 25
END IF

IF gebouwsoort$(gebouwen) = "Spice Silo" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 5
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 5
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 5
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 5
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 5
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 5
END IF

IF gebouwsoort$(gebouwen) = "Turret" THEN
IF gebouwhouse$(gebouwen) = "Ordos" THEN mino = mino + 10
IF gebouwhouse$(gebouwen) = "Atreides" THEN mina = mina + 10
IF gebouwhouse$(gebouwen) = "Sardaukar" THEN mins = mins + 10
IF gebouwhouse$(gebouwen) = "Harkonnen" THEN minh = minh + 10
IF gebouwhouse$(gebouwen) = "Mercenary" THEN minm = minm + 10
IF gebouwhouse$(gebouwen) = "Fremen" THEN minf = minf + 10
END IF
        

      gebouwen$ = STR$(gebouwen)
      gebouwen$ = RIGHT$(gebouwen$, LEN(gebouwen$) - 1)
      cell$(gebouwen) = STR$(cell)
      cell$(gebouwen) = RIGHT$(cell$(gebouwen), LEN(cell$(gebouwen)) - 1)
       
      IF gebouwen < 10 AND gebouwen > -1 THEN num1$(gebouwen) = "00" + gebouwen$
      IF gebouwen < 100 AND gebouwen > 9 THEN num1$(gebouwen) = "0" + gebouwen$
     
gebouwen = gebouwen + 1
plaatsalles
lijnen
      gebouwlaatstneergezet = 1: unitlaatstneergezet = 0: fieldlaatstneergezet = 0: bloomlaatstneergezet = 0
      wiszijkant
END IF
'De Gebouwen ROUTINE WORDT AFGESLOTEN...
k$ = ""
nr = 0
END IF

IF k$ = "m" THEN
wiszijkant
LOCATE 10, 50: PRINT "-----------------------   "
LOCATE 11, 50: PRINT "MENU                      "
LOCATE 12, 50: PRINT "-----------------------   "
LOCATE 14, 50: PRINT "1. Open File     "
LOCATE 15, 50: PRINT "2. Open SeedMap  "
LOCATE 16, 50: PRINT "3. New...        "
LOCATE 17, 50: PRINT "4. Save file     "
LOCATE 19, 50: PRINT "5. Quit          "
COLOR 15: LOCATE 20, 50: INPUT "NR. ", mennummer: COLOR 7
IF mennummer < 1 OR mennummer > 5 THEN wiszijkant: GOTO opnieuw

IF mennummer = 1 THEN
openensnel:
huizen
aa:
COLOR 14: LOCATE 41, 53: INPUT "NR.     ", hn: COLOR 7
IF hn < 1 OR hn > 6 THEN GOTO aa
IF hn = 1 THEN h$ = "A"
IF hn = 2 THEN h$ = "O"
IF hn = 3 THEN h$ = "H"
IF hn = 4 THEN h$ = "S"
IF hn = 5 THEN h$ = "M"
IF hn = 6 THEN h$ = "F"
bb:
COLOR 14: LOCATE 42, 53: INPUT "Level NR:", L$: COLOR 7
IF L$ = "" THEN GOTO bb
IF LEN(L$) = 1 THEN bs$ = "SCEN" + h$ + "00" + L$
IF LEN(L$) = 2 THEN bs$ = "SCEN" + h$ + "0" + L$
wiszijkant
bestandopenen bs$
k$ = ""
bewaarbestand$ = bs$ + ".ini"
eenkeer = 1
GOTO opnieuw
END IF

IF mennummer = 2 THEN
COLOR 15: LOCATE 21, 50: INPUT "Filename    :", bss$: COLOR 7
IF bss$ = "" THEN geenmapladen = 1: GOTO ll
scherm
geenmapladen = 0
mapopenen bss$
ll:
plaatsalles
tekenschaal
lijnen

k$ = ""
wiszijkant
GOTO opnieuw
END IF


IF mennummer = 3 THEN
herstart
spelercr$ = ""
eenkeer = 1
eenleesregel = 0
huizen
LOCATE 41, 50: INPUT "Who is the player ? NR.", spelernr
LOCATE 42, 50: INPUT "Starting credits ?    :", spelercredits
LOCATE 43, 50: INPUT "In which level ?      :", lev
LOCATE 44, 50: INPUT "Quota ?               :", quota$
IF spelernr = 1 THEN h$ = "A": bhuis$ = "Atreides"
IF spelernr = 2 THEN h$ = "O": bhuis$ = "Ordos"
IF spelernr = 3 THEN h$ = "H": bhuis$ = "Harkonnen"
IF spelernr = 4 THEN h$ = "S": bhuis$ = "Sardaukar"
IF spelernr = 5 THEN h$ = "M": bhuis$ = "Mercenary"
IF spelernr = 6 THEN h$ = "F": bhuis$ = "Fremen"
levl$ = STR$(lev)
levl$ = RIGHT$(levl$, LEN(levl$) - 1)
L$ = levl$
IF LEN(levl$) = 2 THEN levl$ = "0" + levl$
IF LEN(levl$) = 1 THEN levl$ = "00" + levl$
bewaarbestand$ = "SCEN" + h$ + levl$ + ".INI"
wiszijkant
lijstplaatjes
bla1:
LOCATE 26, 53: INPUT "Lose Picture :", plaatjenr(1)
IF plaatjenr(1) < 1 OR plaatjenr(1) > 13 THEN GOTO bla1
bla2:
LOCATE 27, 53: INPUT "Win Picture  :", plaatjenr(2)
IF plaatjenr(2) < 1 OR plaatjenr(2) > 13 THEN GOTO bla2
bla3:
LOCATE 28, 53: INPUT "Brief Picture:", plaatjenr(3)
IF plaatjenr(3) < 1 OR plaatjenr(3) > 13 THEN GOTO bla3

FOR bla = 1 TO 3
IF plaatjenr(bla) = 1 THEN plaatje$(bla) = "WIN1.WSA"
IF plaatjenr(bla) = 2 THEN plaatje$(bla) = "WIN2.WSA"
IF plaatjenr(bla) = 3 THEN plaatje$(bla) = "LOSTBILD.WSA"
IF plaatjenr(bla) = 4 THEN plaatje$(bla) = "LOSTVEHC.WSA"
IF plaatjenr(bla) = 5 THEN plaatje$(bla) = "HARVEST.WSA"
IF plaatjenr(bla) = 6 THEN plaatje$(bla) = "HEADQRTS.WSA"
IF plaatjenr(bla) = 7 THEN plaatje$(bla) = "QUAD.WSA"
IF plaatjenr(bla) = 8 THEN plaatje$(bla) = "LTANK.WSA"
IF plaatjenr(bla) = 9 THEN plaatje$(bla) = "REPAIR.WSA"
IF plaatjenr(bla) = 10 THEN plaatje$(bla) = "HVYFTRY.WSA"
IF plaatjenr(bla) = 11 THEN plaatje$(bla) = "IX.WSA"
IF plaatjenr(bla) = 12 THEN plaatje$(bla) = "PALACE.WSA"
IF plaatjenr(bla) = 13 THEN plaatje$(bla) = "SARDUKAR.WSA"
NEXT bla

COLOR 14: LOCATE 30, 53: PRINT "Scale Options": COLOR 7
LOCATE 32, 53: PRINT "0. Big Map"
LOCATE 33, 53: PRINT "1. Small Map"
schaalvraag:
LOCATE 35, 53: INPUT "Scale NR:", schaal
IF schaal < 0 OR schaal > 1 THEN GOTO schaalvraag:
scherm
tekenschaal
spelercr$ = STR$(spelercredits)
spelercr$ = RIGHT$(spelercr$, LEN(spelercr$) - 1)
schaalsave$ = STR$(schaal)
schaalsave$ = RIGHT$(schaalsave$, LEN(schaalsave$) - 1)
k$ = ""
wiszijkant
GOTO opnieuw
END IF

IF mennummer = 5 THEN END

IF mennummer = 4 THEN
bewaarsnel:
redbestand:
IF eenkeer = 0 THEN
bericht$ = "No file to save!  (M + 3)      "
berichtteller = 0
IF foutgehad = 1 THEN
SCREEN 0
CLS
PRINT "Your file could not be saved.... there was no file loaded or no new file.."
END
END IF
GOTO opnieuw
END IF

schermtekening = 1
tpy = cuy
tpx = cux
th = atreidesgeb + ordosgeb + harkonnengeb + sardaukargeb + mercenarygeb + fremengeb
schaalsave$ = STR$(schaal)
schaalsave$ = RIGHT$(schaalsave$, LEN(schaalsave$) - 1)
OPEN "LEVELS\" + bewaarbestand$ FOR OUTPUT AS #1
IF eenleesregel = 0 THEN PRINT #1, "; Scenario "; L$; " control for House "; bhuis$
IF eenleesregel = 1 THEN PRINT #1, boven$
PRINT #1, "; This level is Created By DUNEDIT Version 1.24"
IF foutgehad = 1 THEN PRINT #1, "; THIS FILE IS MADE BECAUSE OF AN ERROR IN DUNEDIT."
IF slainfo = 1 THEN
PRINT #1, "; Power Info:"
PRINT #1, "; Always PowerOut=100"
PRINT #1, "; Atreides  Needs:"; pa
PRINT #1, "; Ordos     Needs:"; po
PRINT #1, "; Harkonnen Needs:"; ph
PRINT #1, "; Sardaukar Needs:"; ps
PRINT #1, "; Mercenary Needs:"; pm
PRINT #1, "; Fremen    Needs:"; pf
END IF
PRINT #1,
PRINT #1, "[BASIC]"
PRINT #1, "LosePicture="; plaatje$(1)
PRINT #1, "WinPicture="; plaatje$(2)
PRINT #1, "BriefPicture="; plaatje$(3)
PRINT #1, "TimeOut=0"
PRINT #1, "MapScale="; schaalsave$
PRINT #1, "CursorPos=0"
IF tacticalpos$ <> "" THEN PRINT #1, "TacticalPos="; tacticalpos$
IF tacticalpos$ = "" THEN PRINT #1, "TacticalPos=0"

IF h$ = "A" OR h$ = "M" THEN
IF L$ = "1" THEN lf$ = "4": wf$ = "6"
IF L$ = "2" THEN lf$ = "5": wf$ = "7"
IF L$ = "3" THEN lf$ = "5": wf$ = "7"
IF L$ = "4" THEN lf$ = "4": wf$ = "6"
IF L$ = "5" THEN lf$ = "1": wf$ = "3"
IF L$ = "6" THEN lf$ = "1": wf$ = "3"
IF L$ = "7" THEN lf$ = "1": wf$ = "3"
IF L$ = "8" THEN lf$ = "1": wf$ = "19"
IF L$ = "9" THEN lf$ = "1": wf$ = "19"
IF L$ = "10" THEN lf$ = "1": wf$ = "19"
END IF
IF h$ = "O" OR h$ = "H" OR h$ = "S" THEN
IF L$ = "1" THEN lf$ = "4": wf$ = "6"
IF L$ = "2" THEN lf$ = "5": wf$ = "23"
IF L$ = "3" THEN lf$ = "5": wf$ = "23"
IF L$ = "4" THEN lf$ = "5": wf$ = "23"
IF L$ = "5" THEN lf$ = "1": wf$ = "19"
IF L$ = "6" THEN lf$ = "1": wf$ = "19"
IF L$ = "7" THEN lf$ = "1": wf$ = "19"
IF L$ = "8" THEN lf$ = "1": wf$ = "19"
IF L$ = "9" THEN lf$ = "1": wf$ = "19"
IF L$ = "10" THEN lf$ = "1": wf$ = "19"
END IF
IF L$ <> "1" AND L$ <> "2" AND L$ <> "3" AND L$ <> "4" AND L$ <> "5" AND L$ <> "6" AND L$ <> "7" AND L$ <> "8" AND L$ <> "9" AND L$ <> "10" THEN lf$ = "1": wf$ = "3"
PRINT #1, "LoseFlags="; lf$
PRINT #1, "WinFlags="; wf$
PRINT #1,
PRINT #1, "[MAP]"

IF fields > 0 THEN
aantalfields = fields - 1
FOR I = 0 TO aantalfields
IF I < aantalfields THEN fieldregel$ = fieldregel$ + fieldcell$(I) + ","
IF I = aantalfields THEN fieldregel$ = fieldregel$ + fieldcell$(I)
NEXT I
PRINT #1, fieldregel$
END IF

IF blooms > 0 THEN
aantalblooms = blooms - 1
FOR I = 0 TO aantalblooms
IF I < aantalblooms THEN bloomregel$ = bloomregel$ + bloomcell$(I) + ","
IF I = aantalblooms THEN bloomregel$ = bloomregel$ + bloomcell$(I)
NEXT I
PRINT #1, bloomregel$
END IF

PRINT #1, "Seed="; bss$
PRINT #1,
bewaarspelers

PRINT #1, "[CHOAM]"
IF trks$ <> "" THEN PRINT #1, "Trike="; trks$
IF qads$ <> "" THEN PRINT #1, "Quad="; qads$
IF tnks$ <> "" THEN PRINT #1, "Tank="; tnks$
IF lncs$ <> "" THEN PRINT #1, "Launcher="; lncs$
IF stks$ <> "" THEN PRINT #1, "Siege Tank="; stks$
IF hrvs$ <> "" THEN PRINT #1, "Harvester="; hrvs$
IF mcvs$ <> "" THEN PRINT #1, "MCV="; mcvs$
IF cars$ <> "" THEN PRINT #1, "Carryall="; cars$
IF devs$ <> "" THEN PRINT #1, "Deviator="; devs$
IF dvas$ <> "" THEN PRINT #1, "Devastator="; dvas$
IF sons$ <> "" THEN PRINT #1, "Sonic Tank="; sons$
IF sols$ <> "" THEN PRINT #1, "Soldier="; sols$
IF trs1$ <> "" THEN PRINT #1, "Troopers="; trs1$
IF trs2$ <> "" THEN PRINT #1, "Trooper="; trs2$
IF infs$ <> "" THEN PRINT #1, "Infantry="; infs$

PRINT #1,

aantalunits = units - 1
IF units > 0 THEN
FOR I = 0 TO aantalunits
opslaanregel1$ = "ID" + num$(I) + "=" + unithouse$(I) + "," + unitsoort$(I) + ",256," + cellu$(I) + ",64," + actie$(I)
IF labelopgeslagen = 0 THEN : PRINT #1, "[UNITS]": labelopgeslagen = 1

PRINT #1, opslaanregel1$

NEXT I
END IF

'Gebouwen Opslaan

aantalgens = gens - 1
FOR I = 0 TO aantalgens
IF labelopgeslagen1 = 0 THEN
PRINT #1,
PRINT #1, "[STRUCTURES]": labelopgeslagen1 = 1
END IF
opslaanregel$ = "GEN" + gencell$(I) + "=" + genhouse$(I) + "," + gensoort$(I)
PRINT #1, opslaanregel$
NEXT I
 
IF gens = 0 AND gebouwen > 0 THEN
IF labelopgeslagen1 = 0 THEN
PRINT #1,
PRINT #1, "[STRUCTURES]": labelopgeslagen1 = 1
END IF
END IF

aantalgebouwen = gebouwen - 1
IF gebouwen > 0 THEN

 
FOR I = 0 TO aantalgebouwen
opslaanregel$ = "ID" + num1$(I) + "=" + gebouwhouse$(I) + "," + gebouwsoort$(I) + ",256," + cell$(I)
doei:
PRINT #1, opslaanregel$
NEXT I
PRINT #1,
END IF


IF reinregels <= 1 THEN GOTO doeija1
FOR I = 1 TO reinregels - 1
        IF reinfkeer = 0 THEN
        PRINT #1,
        PRINT #1, "[REINFORCEMENTS]"
        reinfkeer = 1
        END IF
       
        PRINT #1, reinfregel$(I)
NEXT I

doeija1:
IF reins <= 1 THEN GOTO doeija
aantalr = reins - 1
FOR I = 1 TO aantalr
reinregel$ = reinr$(I) + "=" + huisrn$(I) + "," + rnunit$(I) + "," + waar$(I) + "," + tu$(I)
IF reinfkeer = 0 THEN
PRINT #1,
PRINT #1, "[REINFORCEMENTS]"
reinfkeer = 1
END IF

PRINT #1, reinregel$
NEXT I

doeija:
  
CLOSE #1
labelopgeslagen1 = 0
labelopgeslagen = 0
reinfkeer = 0
bericht$ = "File Saved...                  ": berichtteller = 0
wiszijkant
k$ = ""
IF foutgehad = 1 THEN
SCREEN 0
CLS
PRINT "Your file is saved before dunedit quit by an error."
PRINT "Your filename:"; bewaarbestand$
PRINT "Restart DUNEDIT and load your scenario. Avoid this error by typing a right filename. "
END
END IF

GOTO opnieuw
END IF

END IF


IF k$ = "o" THEN
wiszijkant
k$ = ""
L$ = ""
LOCATE 11, 50: PRINT "--------OPTIONS---------"
 
DO UNTIL L$ = CHR$(27)
L$ = INKEY$
IF schermtekening = 1 THEN tbs$ = "YES" ELSE tbs$ = "NO "
IF slainfo = 1 THEN tbs2$ = "YES" ELSE tbs2$ = "NO "
LOCATE 14, 50: PRINT "1.Tactical Position:"; tbs$
LOCATE 15, 50: PRINT "2.Save Level Info  :"; tbs2$
IF L$ = "1" AND schermtekening = 1 THEN schermtekening = 0: GOTO door
IF L$ = "1" AND schermtekening = 0 THEN schermtekening = 1: GOTO door
IF L$ = "2" AND slainfo = 1 THEN slainfo = 0: GOTO door
IF L$ = "2" AND slainfo = 0 THEN slainfo = 1: GOTO door
door:
LOCATE 20, 50: PRINT "Press ESC to confirm"
LOOP

IF schermtekening = 0 THEN lijnen
OPEN "DUNEDIT.DAT" FOR OUTPUT AS #1
PRINT #1, schermtekening, animatie, geregd, slainfo
FOR I = 1 TO 6
PRINT #1, defaulthouse$(I)
NEXT I
FOR I = 1 TO 5
PRINT #1, defaultactie$(I)
NEXT I
CLOSE #1
wiszijkant
k$ = ""
END IF

IF schermtekening = 1 THEN

ltpx = lpx * 6 + 1
ltpy = lpy * 6
LINE (ltpx, ltpy)-(ltpx + 90, ltpy + 60), 15, B
END IF

IF k$ = "T" OR k$ = "t" THEN
IF ltpx = 0 THEN ltpx = 1
LINE (ltpx, ltpy)-(ltpx + 90, ltpy + 60), 0, B
lpx = cux
lpy = cuy
ltpx = cux * 6 + 1
ltpy = xuy * 6
 
tacticalpos$ = STR$(cell)
tacticalpos$ = RIGHT$(tacticalpos$, LEN(tacticalpos$) - 1)
schermtekening = 1

k$ = ""
GOTO opnieuw
END IF

 
IF k$ = CHR$(27) THEN
wiszijkant
LOCATE 10, 50: PRINT "Quit ? Y/N"
DO
lul$ = INKEY$
IF lul$ = "y" OR lul$ = "Y" THEN END
IF lul$ = "n" OR lul$ = "N" THEN EXIT DO
IF lul$ <> "n" OR lul$ <> "N" OR lul$ <> "Y" OR lul$ <> "y" THEN lul$ = ""
LOOP
wiszijkant
lul$ = ""
GOTO opnieuw
END IF


IF k$ = "s" OR k$ = "S" THEN
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF
         
IF gens + 1 >= 500 THEN
bericht$ = "Cannot create more Walls/Slabs."
berichtteller = 0
k$ = ""
GOTO opnieuw
END IF
 
gensoort$(gens) = "Concrete"
genhouse$(gens) = defaulthouse$(nrdh)
xpos = cux * 6 + 1
ypos = cuy * 6
'LINE (xpos, ypos)-(xpos + 6, ypos + 6), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 1), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 1, ypos + 5), 7, BF
     
      gencell$(gens) = STR$(cell)
      gencell$(gens) = RIGHT$(gencell$(gens), LEN(gencell$(gens)) - 1)
         
gens = gens + 1
wiszijkant
k$ = ""
GOTO opnieuw
END IF

IF k$ = "w" OR k$ = "W" THEN
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF
IF gens + 1 >= 500 THEN
bericht$ = "Cannot create more Walls/Slabs."
berichtteller = 0
k$ = ""
GOTO opnieuw
END IF

gensoort$(gens) = "Wall"
genhouse$(gens) = defaulthouse$(nrdh)

xpos = cux * 6 + 1
ypos = cuy * 6
'LINE (xpos, ypos)-(xpos + 6, ypos + 6), 7, BF
'LINE (xpos, ypos)-(xpos + 3, ypos + 6), 0
'LINE (xpos + 6, ypos)-(xpos + 3, ypos + 6), 0
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos), 15, BF
LINE (xpos + 1, ypos + 1)-(xpos + 1, ypos + 5), 15, BF
LINE (xpos + 5, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
LINE (xpos + 5, ypos + 1)-(xpos + 5, ypos + 5), 8, BF


      gencell$(gens) = STR$(cell)
      gencell$(gens) = RIGHT$(gencell$(gens), LEN(gencell$(gens)) - 1)
gens = gens + 1
wiszijkant
k$ = ""
GOTO opnieuw
END IF

IF k$ = "R" OR k$ = "r" THEN
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF
wiszijkant
COLOR 14: LOCATE 10, 53: PRINT "Add REINFORCEMENT"
COLOR 7
huisrn$(reins) = defaulthouse$(nrdh)
LOCATE 12, 53: PRINT "Transports what?"
lijstvanunits
COLOR 8
LOCATE 15, 52: PRINT " 0- Sand Worm"
LOCATE 30, 52: PRINT "15- CarryAll"
COLOR 7
 
unropnieuw:
LOCATE 50, 53: INPUT "Unit NR:", unr
IF unr < 1 OR unr > 16 THEN GOTO unropnieuw ELSE GOTO doeii
IF unr = 15 THEN k$ = "": wiszijkant: GOTO opnieuw
doeii:

      IF unr = 1 THEN rnunit$(reins) = "Soldier"
      IF unr = 2 THEN rnunit$(reins) = "Infantry"
      IF unr = 3 THEN rnunit$(reins) = "Trike"
      IF unr = 4 THEN rnunit$(reins) = "Raider Trike"
      IF unr = 5 THEN rnunit$(reins) = "Quad"
      IF unr = 6 THEN rnunit$(reins) = "Trooper"
      IF unr = 7 THEN rnunit$(reins) = "Troopers"
      IF unr = 8 THEN rnunit$(reins) = "Tank"
      IF unr = 9 THEN rnunit$(reins) = "Launcher"
      IF unr = 10 THEN rnunit$(reins) = "Siege Tank"
      IF unr = 11 THEN rnunit$(reins) = "Deviator"
      IF unr = 12 THEN rnunit$(reins) = "Sonic Tank"
      IF unr = 13 THEN rnunit$(reins) = "Devastator"
      IF unr = 15 THEN rnunit$(reins) = "Harvester"
      IF unr = 16 THEN rnunit$(reins) = "MCV"

wiszijkant
COLOR 14: LOCATE 10, 53: PRINT "Add REINFORCEMENT"
COLOR 7
LOCATE 12, 53: PRINT "Where ?"
LOCATE 14, 53: PRINT "1.To ENEMYBASE "
LOCATE 15, 53: PRINT "2.To HOMEBASE "
foutje:
LOCATE 17, 53: INPUT "NR. ", rnfw
IF rnfw < 1 OR rnfw > 2 THEN GOTO foutje
IF rnfw = 1 THEN waar$(reins) = "Enemybase"
IF rnfw = 2 THEN waar$(reins) = "Homebase"
LOCATE 19, 53: PRINT "About NR TimeUnits ?"
LOCATE 21, 53: INPUT "TimeUnits:", tu$(reins)
reinfnr = reinfnr + 1
reinr$(reins) = STR$(reinfnr)
reinr$(reins) = RIGHT$(reinr$(reins), LEN(reinr$(reins)) - 1)
reins = reins + 1
aantalreins = aantalreins + 1
wiszijkant
k$ = ""
GOTO opnieuw
END IF


IF k$ = "c" THEN
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF
LOCATE 10, 53: PRINT "STARPORT RESCOURSE EDIT"
LOCATE 12, 53: PRINT "   Fill in how many a"
LOCATE 13, 53: PRINT "   starport can have."
LOCATE 15, 53: INPUT "Trike(s)     :", trks$
LOCATE 16, 53: INPUT "Quad(s)      :", qads$
LOCATE 17, 53: INPUT "Tank(s)      :", tnks$
LOCATE 18, 53: INPUT "Launcher(s)  :", lncs$
LOCATE 19, 53: INPUT "Siege Tnk(s) :", stks$
LOCATE 20, 53: INPUT "Harvester(s) :", hrvs$
LOCATE 21, 53: INPUT "MCV(s)       :", mcvs$
LOCATE 22, 53: INPUT "Carryall(s)  :", cars$
LOCATE 23, 53: INPUT "Devastator(s):", dvas$
LOCATE 24, 53: INPUT "Deviator(s)  :", devs$
LOCATE 25, 53: INPUT "Sonic Tank(s):", sons$
LOCATE 26, 53: INPUT "Infantry(s)  :", infs$
LOCATE 27, 53: INPUT "Soldier(s)   :", sols$
LOCATE 28, 53: INPUT "Trooper(s)   :", trs2$
LOCATE 29, 53: INPUT "Team Troopers:", trs1$
wiszijkant
k$ = ""
GOTO opnieuw
END IF

IF k$ = "u" THEN delprocedure: k$ = "": GOTO opnieuw

IF k$ = "f" THEN
IF fields >= 50 THEN bericht$ = "No more than 50 fields allowed.": berichtteller = 0: GOTO opnieuw
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF
fieldcell$(fields) = STR$(cell)
fieldcell$(fields) = RIGHT$(fieldcell$(fields), LEN(fieldcell$(fields)) - 1)
fields = fields + 1
gebouwlaatstneergezet = 0: unitlaatstneergezet = 0: fieldlaatstneergezet = 1: bloomlaatstneergezet = 0
plaatsalles
lijnen
k$ = ""
END IF

IF k$ = "b" THEN
IF blooms >= 50 THEN bericht$ = "No more than 50 blooms allowed.": berichtteller = 0: GOTO opnieuw
IF eenkeer = 0 THEN
bericht$ = "Create a new file! M + 3       "
berichtteller = 0
GOTO opnieuw
END IF
bloomcell$(blooms) = STR$(cell)
bloomcell$(blooms) = RIGHT$(bloomcell$(blooms), LEN(bloomcell$(blooms)) - 1)
blooms = blooms + 1
gebouwlaatstneergezet = 0: unitlaatstneergezet = 0: fieldlaatstneergezet = 0: bloomlaatstneergezet = 1
plaatsalles
lijnen
k$ = ""
END IF

IF k$ = "l" THEN
'Place a list of seeds....
CLS     'clear screen
SHELL "DIR SEED\*.map /W"
LOCATE 56, 1: PRINT "Press a Key to return to dunedit. Press V to use the seed-Viewer."
DO
q$ = INKEY$
IF q$ <> "V" AND q$ <> "v" AND q$ <> "" THEN EXIT DO

IF q$ = "V" OR q$ = "v" THEN
LOCATE 55, 1: INPUT "FILENAME(NO EXTENTION!):", kijk$
CLS
LINE (1, 1)-(384, 384), 6, BF   'Draws the SAND area
mapopenen kijk$         'Load the seed map.
lijnen                  'Draws, creates the cell blocks on the screen
LOCATE 56, 1: PRINT "Press a Key..."
WHILE INKEY$ = "": WEND
CLS
SHELL "DIR SEED\*.map /W"
LOCATE 56, 1: PRINT "Press a Key to return to dunedit. Press V to view a seednr"
END IF


LOOP

CLS
scherm                  'Draw Interface!
zettoetsen              'Draw Interface!!!

IF geenmapladen = 0 THEN mapopenen bss$
plaatsalles             'place all things that have to be placed.
tekenschaal
lijnen
END IF


LOOP

fouten:
IF ERR = 53 THEN
foutgehad = 1
RESUME redbestand
END IF

PRINT "Error Code:"; ERR
END

SUB acties
wiszijkant
LOCATE 19, 53: PRINT "1 - Guard      "
LOCATE 20, 53: PRINT "2 - Area Guard  "
LOCATE 21, 53: PRINT "3 - Ambush      "
LOCATE 22, 53: PRINT "4 - Hunt       "
LOCATE 23, 53: PRINT "5 - Harvest     "
END SUB

SUB Atreidessub
INPUT #1, deel4$

IF LEFT$(deel4$, 7) = "Credits" THEN atc$ = RIGHT$(deel4$, LEN(deel4$) - 8)
IF LEFT$(deel4$, 5) = "Quota" THEN q$ = RIGHT$(deel4$, LEN(deel4$) - 6)

IF LEFT$(deel4$, 5) = "Brain" THEN
orsp$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF orsp$ = "Human" THEN spelernr = 1: spelercr$ = atc$: quota$ = q$
END IF

atreidesgeb = 1
END SUB

SUB basicsub
INPUT #1, deel5$

IF LEFT$(deel5$, 11) = "LosePicture" THEN plaatje$(1) = RIGHT$(deel5$, LEN(deel5$) - 12)
IF LEFT$(deel5$, 10) = "WinPicture" THEN plaatje$(2) = RIGHT$(deel5$, LEN(deel5$) - 11)
IF LEFT$(deel5$, 12) = "BriefPicture" THEN plaatje$(3) = RIGHT$(deel5$, LEN(deel5$) - 13)

IF LEFT$(deel5$, 8) = "MapScale" THEN
ms$ = RIGHT$(deel5$, LEN(deel5$) - 9)
schaal = VAL(ms$)
tekenschaal
geenbelang:
END IF

IF LEFT$(deel5$, 11) = "TacticalPos" THEN
tp$ = RIGHT$(deel5$, LEN(deel5$) - 12)
tacticalpos$ = tp$
tpcell = VAL(tp$)
gevonden = 0
lpy = INT(tpcell / 64)
lpx = tpcell - (lpy * 64)
EXIT SUB
END IF

END SUB

SUB bestandopenen (B$)
scherm
herstart
proc = 0
bericht$ = "                               "
COLOR 15: LOCATE 8, 50: PRINT bericht$: COLOR 7

BESTAND$ = "LEVELS\" + B$ + ".ini"
OPEN BESTAND$ FOR INPUT AS #1
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF

DO WHILE NOT EOF(1)

IF eenleesregel = 0 THEN LINE INPUT #1, boven$: eenleesregel = 1
IF gevonden = 0 THEN FOR w = 0 TO 50: NEXT w
IF gevonden = 1 THEN FOR w = 0 TO 50: NEXT w

opnieuwregellezen:
IF gevonden = 0 THEN INPUT #1, regel$

IF regel$ = "[BASIC]" THEN
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF
gevonden = 1
basicsub
END IF

IF regel$ = "[CHOAM]" THEN
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF
gevonden = 1
choambalk
END IF

IF regel$ = "[Sardaukar]" THEN
sardaukargevonden = 1
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF
gevonden = 1
Sardaukarsub
r = r + 1
IF r > 4 THEN gevonden = 0: r = 0
END IF

IF regel$ = "[Ordos]" THEN
proc = proc + 6: gevonden = 1
LINE (393, 53)-(393 + proc, 63), 7, BF
Ordossub
r = r + 1
IF r > 4 THEN gevonden = 0: r = 0
END IF

IF regel$ = "[Atreides]" THEN
proc = proc + 6: gevonden = 1
LINE (393, 53)-(393 + proc, 63), 7, BF
Atreidessub
r = r + 1
IF r > 4 THEN gevonden = 0: r = 0
END IF

IF regel$ = "[Harkonnen]" THEN
proc = proc + 6: gevonden = 1
LINE (393, 53)-(393 + proc, 63), 7, BF
harkonnensub
r = r + 1
IF r > 4 THEN gevonden = 0: r = 0
END IF

IF regel$ = "[Mercenary]" THEN
proc = proc + 6: gevonden = 1
LINE (393, 53)-(393 + proc, 63), 7, BF
mercenarysub
r = r + 1
IF r > 4 THEN gevonden = 0: r = 0
END IF

IF regel$ = "[Fremen]" THEN
proc = proc + 6: gevonden = 1
LINE (393, 53)-(393 + proc, 63), 7, BF
fremensub
r = r + 1
IF r > 4 THEN gevonden = 0: r = 0
END IF

IF regel$ = "[MAP]" THEN
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF
gevonden = 1
mapsub
END IF

'[STRUCTURES]
IF regel$ = "[STRUCTURES]" THEN
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF
       
        gevonden = 1
        gebouwsub
END IF
 
'[UNITS]
        IF regel$ = "[UNITS]" THEN
proc = proc + 6
'PROCENTENBALK
LINE (393, 53)-(393 + proc, 63), 7, BF
                gevonden = 1
                unitssub
        END IF

IF regel$ = "[REINFORCEMENTS]" THEN
proc = proc + 1
reinfkeer = 1
gevonden = 1
reinfsub
END IF

LOOP

stoppen:
CLOSE #1

lijnen
FOR p = 50 TO 55
LOCATE p, 1: PRINT "                                                                              "
NEXT p
zettoetsen
 
bericht$ = "File Loaded..                  "
berichtteller = 0

plaatsalles
tekenschaal
lijnen
verren = 1
END SUB

SUB bewaarspelers
'Bewaart Spelers in het bestand. Kortere routine...
PRINT #1, ""
IF ordosgeb = 1 THEN
PRINT #1, "[Ordos]"
IF spelernr = 2 THEN
PRINT #1, "Quota="; quota$
PRINT #1, "Credits="; spelercr$
PRINT #1, "Brain=Human"
PRINT #1, "MaxUnits=30"
ELSE
PRINT #1, "Quota=0"
PRINT #1, "Credits=1000"
PRINT #1, "Brain=CPU"
PRINT #1, "MaxUnits=25"
END IF
PRINT #1, ""
END IF

IF atreidesgeb = 1 THEN
PRINT #1, "[Atreides]"
IF spelernr = 1 THEN
PRINT #1, "Quota="; quota$
PRINT #1, "Credits="; spelercr$
PRINT #1, "Brain=Human"
PRINT #1, "MaxUnits=30"
ELSE
PRINT #1, "Quota=0"
PRINT #1, "Credits=1000"
PRINT #1, "Brain=CPU"
PRINT #1, "MaxUnits=25"
END IF
PRINT #1, ""
END IF

IF harkonnengeb = 1 THEN
PRINT #1, "[Harkonnen]"
IF spelernr = 3 THEN
PRINT #1, "Quota="; quota$
PRINT #1, "Credits="; spelercr$
PRINT #1, "Brain=Human"
PRINT #1, "MaxUnits=30"
ELSE
PRINT #1, "Quota=0"
PRINT #1, "Credits=1000"
PRINT #1, "Brain=CPU"
PRINT #1, "MaxUnits=25"
END IF
PRINT #1, ""
END IF

IF sardaukargeb = 1 THEN
PRINT #1, "[Sardaukar]"
IF spelernr = 4 THEN
PRINT #1, "Quota="; quota$
PRINT #1, "Credits="; spelercr$
PRINT #1, "Brain=Human"
PRINT #1, "MaxUnits=30"
ELSE
PRINT #1, "Quota=0"
PRINT #1, "Credits=1000"
PRINT #1, "Brain=CPU"
PRINT #1, "MaxUnits=25"
END IF
PRINT #1, ""
END IF

IF mercenarygeb = 1 THEN
PRINT #1, "[Mercenary]"
IF spelernr = 5 THEN
PRINT #1, "Quota="; quota$
PRINT #1, "Credits="; spelercr$
PRINT #1, "Brain=Human"
PRINT #1, "MaxUnits=30"
ELSE
PRINT #1, "Quota=0"
PRINT #1, "Credits=1000"
PRINT #1, "Brain=CPU"
PRINT #1, "MaxUnits=25"
END IF
PRINT #1, ""
END IF

IF fremengeb = 1 THEN
PRINT #1, "[Fremen]"
IF spelernr = 6 THEN
PRINT #1, "Quota="; quota$
PRINT #1, "Credits="; spelercr$
PRINT #1, "Brain=Human"
PRINT #1, "MaxUnits=30"
ELSE
PRINT #1, "Quota=0"
PRINT #1, "Credits=1500"
PRINT #1, "Brain=CPU"
PRINT #1, "MaxUnits=25"
END IF
PRINT #1, ""
END IF

END SUB

SUB choambalk
INPUT #1, deel6$

IF LEFT$(deel6$, 5) = "Trike" THEN trks$ = RIGHT$(deel6$, LEN(deel6$) - 6)
IF LEFT$(deel6$, 4) = "Quad" THEN qads$ = RIGHT$(deel6$, LEN(deel6$) - 5)
IF LEFT$(deel6$, 4) = "Tank" THEN tnks$ = RIGHT$(deel6$, LEN(deel6$) - 5)
IF LEFT$(deel6$, 8) = "Launcher" THEN lncs$ = RIGHT$(deel6$, LEN(deel6$) - 9)
IF LEFT$(deel6$, 10) = "Siege Tank" THEN stks$ = RIGHT$(deel6$, LEN(deel6$) - 11)
IF LEFT$(deel6$, 9) = "Harvester" THEN hrvs$ = RIGHT$(deel6$, LEN(deel6$) - 10)
IF LEFT$(deel6$, 3) = "MCV" THEN mcvs$ = RIGHT$(deel6$, LEN(deel6$) - 4)
IF LEFT$(deel6$, 8) = "Carryall" THEN cars$ = RIGHT$(deel6$, LEN(deel6$) - 9)
IF LEFT$(deel6$, 10) = "Devastator" THEN dvas$ = RIGHT$(deel6$, LEN(deel6$) - 11)
IF LEFT$(deel6$, 8) = "Deviator" THEN devs$ = RIGHT$(deel6$, LEN(deel6$) - 9)
IF LEFT$(deel6$, 10) = "Sonic Tank" THEN sons$ = RIGHT$(deel6$, LEN(deel6$) - 11)
IF LEFT$(deel6$, 7) = "Trooper" THEN trs2$ = RIGHT$(deel6$, LEN(deel6$) - 8)
IF LEFT$(deel6$, 8) = "Troopers" THEN trs1$ = RIGHT$(deel6$, LEN(deel6$) - 9)
IF LEFT$(deel6$, 8) = "Infantry" THEN infs$ = RIGHT$(deel6$, LEN(deel6$) - 9)
IF LEFT$(deel6$, 7) = "Soldier" THEN sols$ = RIGHT$(deel6$, LEN(deel6$) - 8)

IF LEN(deel6$) < 1 THEN gevonden = 0: EXIT SUB
END SUB

SUB delprocedure
IF gebouwen = 0 AND units = 0 AND blooms = 0 AND fields = 0 THEN bericht$ = "There is nothing to delete.    ": EXIT SUB

IF unitlaatstneergezet = 1 THEN
IF units = 0 THEN bericht$ = "No Units to delete.           ": EXIT SUB
units = units - 1
END IF

IF gebouwlaatstneergezet = 1 THEN
IF gebouwen = 0 THEN bericht$ = "No Structures to delete.       ": EXIT SUB
IF gebouwsoort$(gebouwen) = "Barracks" OR gebouwsoort$(gebouwen - 1) = "Light Fctry" OR gebouwsoort$(gebouwen - 1) = "Repair" OR gebouwsoort$(gebouwen - 1) = "WOR" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 20
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 20
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 20
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 20
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 20
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 20
END IF

IF gebouwsoort$(gebouwen - 1) = "Heavy Fctry" OR gebouwsoort$(gebouwen - 1) = "Hi-Tech" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 35
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 35
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 35
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 35
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 35
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 35
END IF

IF gebouwsoort$(gebouwen - 1) = "Palace" OR gebouwsoort$(gebouwen) = "Starport" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 80
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 80
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 80
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 80
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 80
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 80
END IF

IF gebouwsoort$(gebouwen - 1) = "Outpost" OR gebouwsoort$(gebouwen - 1) = "Refinery" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 30
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 30
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 30
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 30
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 30
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 30
END IF

IF gebouwsoort$(gebouwen - 1) = "IX" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 40
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 40
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 40
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 40
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 40
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 40
END IF

IF gebouwsoort$(gebouwen - 1) = "R-Turret" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 25
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 25
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 25
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 25
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 25
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 25
END IF

IF gebouwsoort$(gebouwen - 1) = "Spice Silo" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 5
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 5
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 5
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 5
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 5
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 5
END IF

IF gebouwsoort$(gebouwen - 1) = "Turret" THEN
IF gebouwhouse$(gebouwen - 1) = "Ordos" THEN mino = mino - 10
IF gebouwhouse$(gebouwen - 1) = "Atreides" THEN mina = mina - 10
IF gebouwhouse$(gebouwen - 1) = "Sardaukar" THEN mins = mins - 10
IF gebouwhouse$(gebouwen - 1) = "Harkonnen" THEN minh = minh - 10
IF gebouwhouse$(gebouwen - 1) = "Mercenary" THEN minm = minm - 10
IF gebouwhouse$(gebouwen - 1) = "Fremen" THEN minf = minf - 10
END IF
gebouwen = gebouwen - 1
END IF

IF fieldlaatstneergezet = 1 THEN fields = fields - 1
IF bloomlaatstneergezet = 1 THEN blooms = blooms - 1

scherm
IF bss$ = "" THEN GOTO stapjeover

IF geenmapladen = 0 THEN mapopenen bss$
    
stapjeover:
plaatsalles

IF units = 0 THEN gebouwlaatstneergezet = 1
IF gebouwen = 0 THEN unitlaatstneergezet = 1

tekenschaal
plaatsalles
lijnen
verren = 1
END SUB

SUB fremensub
INPUT #1, deel4$

IF LEFT$(deel4$, 7) = "Credits" THEN frc$ = RIGHT$(deel4$, LEN(deel4$) - 8)
IF LEFT$(deel4$, 5) = "Quota" THEN q$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF LEFT$(deel4$, 5) = "Brain" THEN
orsp$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF orsp$ = "Human" THEN spelernr = 6: spelercr$ = frc$: quota$ = q$
END IF

fremengeb = 1
END SUB

SUB gebouwsub
INPUT #1, deel1$

IF LEFT$(deel1$, 3) = "GEN" THEN
IF MID$(deel1$, 9, 1) = "O" THEN ordos = 1
IF MID$(deel1$, 8, 1) = "O" THEN ordos = 1
IF MID$(deel1$, 7, 1) = "O" THEN ordos = 1
IF MID$(deel1$, 9, 1) = "A" THEN atreides = 1
IF MID$(deel1$, 8, 1) = "A" THEN atreides = 1
IF MID$(deel1$, 7, 1) = "A" THEN atreides = 1
IF MID$(deel1$, 9, 1) = "H" THEN harkonnen = 1
IF MID$(deel1$, 8, 1) = "H" THEN harkonnen = 1
IF MID$(deel1$, 7, 1) = "H" THEN harkonnen = 1
IF MID$(deel1$, 9, 1) = "S" THEN sardaukar = 1
IF MID$(deel1$, 8, 1) = "S" THEN sardaukar = 1
IF MID$(deel1$, 7, 1) = "S" THEN sardaukar = 1
IF MID$(deel1$, 9, 1) = "F" THEN fremen = 1
IF MID$(deel1$, 8, 1) = "F" THEN fremen = 1
IF MID$(deel1$, 7, 1) = "F" THEN fremen = 1
IF MID$(deel1$, 9, 1) = "M" THEN mercenary = 1
IF MID$(deel1$, 8, 1) = "M" THEN mercenary = 1
IF MID$(deel1$, 7, 1) = "M" THEN mercenary = 1

gcell$ = RIGHT$(deel1$, LEN(deel1$) - 3)

IF ordos = 1 THEN
gencell$(gens) = LEFT$(gcell$, LEN(gcell$) - 6)
genhouse$(gens) = "Ordos"
END IF

IF atreides = 1 THEN
gencell$(gens) = LEFT$(gcell$, LEN(gcell$) - 9)
genhouse$(gens) = "Atreides"
END IF

IF sardaukar = 1 THEN
gencell$(gens) = LEFT$(gcell$, LEN(gcell$) - 10)
genhouse$(gens) = "Sardaukar"
END IF

IF harkonnen = 1 THEN
gencell$(gens) = LEFT$(gcell$, LEN(gcell$) - 10)
genhouse$(gens) = "Harkonnen"
END IF

IF mercenary = 1 THEN
gencell$(gens) = LEFT$(gcell$, LEN(gcell$) - 10)
genhouse$(gens) = "Mercenary"
END IF

IF fremen = 1 THEN
gencell$(gens) = LEFT$(gcell$, LEN(gcell$) - 7)
genhouse$(gens) = "Fremen"
END IF


INPUT #1, gensoort$(gens)

cell = VAL(gencell$(gens))
cuy = INT(cell / 64)
cux = cell - (cuy * 64)

xpos = cux * 6 + 1
ypos = cuy * 6
IF gensoort$(gens) = "Wall" THEN
'LINE (xpos, ypos)-(xpos + 6, ypos + 6), 7, BF
'LINE (xpos, ypos)-(xpos + 3, ypos + 6), 0
'LINE (xpos + 6, ypos)-(xpos + 3, ypos + 6), 0
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos), 15, BF
LINE (xpos + 1, ypos + 1)-(xpos + 1, ypos + 5), 15, BF
LINE (xpos + 5, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
LINE (xpos + 5, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
END IF

IF gensoort$(gens) = "Concrete" THEN
'LINE (xpos, ypos)-(xpos + 6, ypos + 6), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 1), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 1, ypos + 5), 7, BF
END IF

gens = gens + 1
EXIT SUB
END IF

IF LEFT$(deel1$, 2) <> "ID" THEN gevonden = 0: EXIT SUB
INPUT #1, soort$, p$, cell$(gebouwen)

IF gebouwen < 10 AND gebouwen > -1 THEN

L$ = STR$(gebouwen)
L$ = RIGHT$(L$, LEN(L$) - 1)
num1$(gebouwen) = "00" + L$
END IF

IF gebouwen < 100 AND gebouwen > 9 THEN
L$ = STR$(gebouwen)
L$ = RIGHT$(L$, LEN(L$) - 1)
num1$(gebouwen) = "0" + L$
END IF

IF gebouwen < 1000 AND gebouwen > 99 THEN
L$ = STR$(gebouwen)
L$ = RIGHT$(L$, LEN(L$) - 1)
num1$(gebouwen) = "" + L$
END IF

cell = VAL(cell$(gebouwen))

ypositie = INT(cell / 64)
xpositie = cell - (ypositie * 64)

gebouwx(gebouwen) = xpositie
gebouwy(gebouwen) = ypositie
gebouwsoort$(gebouwen) = soort$


deel1$ = RIGHT$(deel1$, LEN(deel1$) - 6)
gebouwhouse$(gebouwen) = deel1$
IF deel1$ = "Ordos" THEN kleur = 2: ordosgeb = 1
IF deel1$ = "Atreides" THEN kleur = 1: atreidesgeb = 1
IF deel1$ = "Sardaukar" THEN kleur = 5: sardaukargeb = 1
IF deel1$ = "Harkonnen" THEN kleur = 4: harkonnengeb = 1
IF deel1$ = "Mercenary" THEN kleur = 0: mercenarygeb = 1
IF deel1$ = "Fremen" THEN kleur = 15: fremengeb = 1

ypositie = ypositie * 6
xpositie = xpositie * 6 + 1

IF soort$ = "Windtrap" THEN
IF deel1$ = "Ordos" THEN factoro = factoro + 1
IF deel1$ = "Atreides" THEN factora = factora + 1
IF deel1$ = "Sardaukar" THEN factors = factors + 1
IF deel1$ = "Harkonnen" THEN factorh = factorh + 1
IF deel1$ = "Mercenary" THEN factorm = factorm + 1
IF deel1$ = "Fremen" THEN factorf = factorf + 1
END IF

IF soort$ = "Barracks" OR soort$ = "Light Fctry" OR soort$ = "Repair" OR soort$ = "WOR" THEN
IF deel1$ = "Ordos" THEN mino = mino + 20
IF deel1$ = "Atreides" THEN mina = mina + 20
IF deel1$ = "Sardaukar" THEN mins = mins + 20
IF deel1$ = "Harkonnen" THEN minh = minh + 20
IF deel1$ = "Mercenary" THEN minm = minm + 20
IF deel1$ = "Fremen" THEN minf = minf + 20
END IF

IF soort$ = "Heavy Fctry" OR soort$ = "Hi-Tech" THEN
IF deel1$ = "Ordos" THEN mino = mino + 35
IF deel1$ = "Atreides" THEN mina = mina + 35
IF deel1$ = "Sardaukar" THEN mins = mins + 35
IF deel1$ = "Harkonnen" THEN minh = minh + 35
IF deel1$ = "Mercenary" THEN minm = minm + 35
IF deel1$ = "Fremen" THEN minf = minf + 35
END IF

IF soort$ = "Palace" OR soort$ = "Starport" THEN
IF deel1$ = "Ordos" THEN mino = mino + 80
IF deel1$ = "Atreides" THEN mina = mina + 80
IF deel1$ = "Sardaukar" THEN mins = mins + 80
IF deel1$ = "Harkonnen" THEN minh = minh + 80
IF deel1$ = "Mercenary" THEN minm = minm + 80
IF deel1$ = "Fremen" THEN minf = minf + 80
END IF

IF soort$ = "Outpost" OR soort$ = "Refinery" THEN
IF deel1$ = "Ordos" THEN mino = mino + 30
IF deel1$ = "Atreides" THEN mina = mina + 30
IF deel1$ = "Sardaukar" THEN mins = mins + 30
IF deel1$ = "Harkonnen" THEN minh = minh + 30
IF deel1$ = "Mercenary" THEN minm = minm + 30
IF deel1$ = "Fremen" THEN minf = minf + 30
END IF

IF soort$ = "IX" THEN
IF deel1$ = "Ordos" THEN mino = mino + 40
IF deel1$ = "Atreides" THEN mina = mina + 40
IF deel1$ = "Sardaukar" THEN mins = mins + 40
IF deel1$ = "Harkonnen" THEN minh = minh + 40
IF deel1$ = "Mercenary" THEN minh = minh + 40
IF deel1$ = "Fremen" THEN minf = minf + 40
END IF

IF soort$ = "R-Turret" THEN
IF deel1$ = "Ordos" THEN mino = mino + 25
IF deel1$ = "Atreides" THEN mina = mina + 25
IF deel1$ = "Sardaukar" THEN mins = mins + 25
IF deel1$ = "Harkonnen" THEN minh = minh + 25
IF deel1$ = "Mercenary" THEN minm = minm + 25
IF deel1$ = "Fremen" THEN minf = minf + 25
END IF

IF soort$ = "Spice Silo" THEN
IF deel1$ = "Ordos" THEN mino = mino + 5
IF deel1$ = "Atreides" THEN mina = mina + 5
IF deel1$ = "Sardaukar" THEN mins = mins + 5
IF deel1$ = "Harkonnen" THEN minh = minh + 5
IF deel1$ = "Mercenary" THEN minh = minh + 5
IF deel1$ = "Fremen" THEN minf = minf + 5
END IF

IF soort$ = "Turret" THEN
IF deel1$ = "Ordos" THEN mino = mino + 10
IF deel1$ = "Atreides" THEN mina = mina + 10
IF deel1$ = "Sardaukar" THEN mins = mins + 10
IF deel1$ = "Harkonnen" THEN minh = minh + 10
IF deel1$ = "Mercenary" THEN minm = minm + 10
IF deel1$ = "Fremen" THEN minf = minf + 10
END IF

gebouwen = gebouwen + 1
overslaan:
END SUB

SUB harkonnensub
INPUT #1, deel4$

IF LEFT$(deel4$, 7) = "Credits" THEN hac$ = RIGHT$(deel4$, LEN(deel4$) - 8)
IF LEFT$(deel4$, 5) = "Brain" THEN
orsp$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF orsp$ = "Human" THEN spelernr = 3: spelercr$ = hac$: quota$ = q$
END IF
IF LEFT$(deel4$, 5) = "Quota" THEN q$ = RIGHT$(deel4$, LEN(deel4$) - 6)
harkonnengeb = 1
END SUB

SUB herstart
harkonnengeb = 0
sardaukargeb = 0
atreidesgeb = 0
ordosgeb = 0
eenkeertjefield = 0
eenkeertjebloom = 0
gens = 0
keer = 0
keer1 = 0
gevonden = 0
gebouwen = 0
units = 0
reins = 1
reinfnr = 0
spelercredits = 0: spelernr = 0: atreidesgeb = 0: harkonnengeb = 0: ordosgeb = 0: sardaukargeb = 0: gebouwen = 0: units = 0
labelopgeslagen1 = 0: mercenarygeb = 0
labelopgeslagen = 0
reingeladen = 0
reinregels = 1
aantalreins = 1
fields = 0
blooms = 0
END SUB

'
SUB huizen
LOCATE 36, 53: PRINT "1.Atreides  6.Fremen"
LOCATE 37, 53: PRINT "2.Ordos"
LOCATE 38, 53: PRINT "3.Harkonnen"
LOCATE 39, 53: PRINT "4.Sardaukar"
LOCATE 40, 53: PRINT "5.Mercenary"
END SUB

SUB introductie
scherm                  'Draw Interface!
zettoetsen              'Draw Interface!!!
lijnen
LINE (150, 150)-(500, 300), 0, BF
LINE (150, 150)-(500, 300), 7, B

LOCATE 20, 20: PRINT "DunEdit Version 1.24"
COLOR 15: LOCATE 24, 20: PRINT "Spell check,new wall/slab details": COLOR 7
COLOR 10: LOCATE 28, 20: PRINT "HTTP://PEOPLE.A2000.NL/RHENDRIK/DUNEII.HTM"
COLOR 10: LOCATE 29, 20: PRINT "E-mail: STEFAN@FLASH.A2000.NL"
COLOR 7
LOCATE 36, 20: PRINT "Press A Key!"
WHILE INKEY$ = "": WEND
CLS
scherm                  'Draw Interface!
zettoetsen              'Draw Interface!!!
lijnen
verren = 1
END SUB

'
SUB lijnen
FOR x = 0 TO 384 STEP 6
LINE (x + 1, 0)-(x + 1, 384), 0
LINE (0, x)-(384, x), 0
NEXT x
END SUB

SUB lijstGebouwen
wiszijkant
LOCATE 19, 52: PRINT " 1- Construction Yard"
LOCATE 20, 52: PRINT " 2- Spice Refinery  "
LOCATE 21, 52: PRINT " 3- Spice Silo      "
LOCATE 22, 52: PRINT " 4- Windtrap        "
LOCATE 23, 52: PRINT " 5- Barracks        "
LOCATE 24, 52: PRINT " 6- Outpost         "
LOCATE 25, 52: PRINT " 7- WOR             "
LOCATE 26, 52: PRINT " 8- Light Factory   "
LOCATE 27, 52: PRINT " 9- Heavy Factory   "
LOCATE 28, 52: PRINT "10- Gun - Turret    "
LOCATE 29, 52: PRINT "11- High-Tech       "
LOCATE 30, 52: PRINT "12- Reapair Station "
LOCATE 31, 52: PRINT "13- Rocket - Turret "
LOCATE 32, 52: PRINT "14- House of IX     "
LOCATE 33, 52: PRINT "15- Palace          "
LOCATE 34, 52: PRINT "16- Starport        "
 
END SUB

SUB lijstplaatjes
wiszijkant
COLOR 14: LOCATE 10, 53: PRINT "Pictures List"
COLOR 7
LOCATE 12, 53: PRINT "1. Win(1)       "
LOCATE 13, 53: PRINT "2. Win(2)       "
LOCATE 14, 53: PRINT "3. Lose(1)      "
LOCATE 15, 53: PRINT "4. Lose(2)      "
LOCATE 16, 53: PRINT "5. Harvester    "
LOCATE 17, 53: PRINT "6. Outpost      "
LOCATE 18, 53: PRINT "7. Quad         "
LOCATE 19, 53: PRINT "8. Light Tank   "
LOCATE 20, 53: PRINT "9. Repair Facility"
LOCATE 21, 53: PRINT "10.Heavy Factory"
LOCATE 22, 53: PRINT "11.House Of IX "
LOCATE 23, 53: PRINT "12.Palace      "
LOCATE 24, 53: PRINT "13.Sardaukar Trooper"
END SUB

SUB lijstvanunits
wiszijkant
LOCATE 15, 52: PRINT " 0- Sand Worm  "
LOCATE 16, 52: PRINT " 1- Soldier"
LOCATE 17, 52: PRINT " 2- Infantry"
LOCATE 18, 52: PRINT " 3- Trike"
LOCATE 19, 52: PRINT " 4- Raider Trike"
LOCATE 20, 52: PRINT " 5- Quad  "
LOCATE 21, 52: PRINT " 6- Trooper   "
LOCATE 22, 52: PRINT " 7- Troopers  "
LOCATE 23, 52: PRINT " 8- Tank"
LOCATE 24, 52: PRINT " 9- Rocket Launcher"
LOCATE 25, 52: PRINT "10- Siege Tank"
LOCATE 26, 52: PRINT "11- Deviator "
LOCATE 27, 52: PRINT "12- Sonic Tank"
LOCATE 28, 52: PRINT "13- Devastator"
LOCATE 29, 52: PRINT "14- Harvester"
LOCATE 30, 52: PRINT "15- CarryAll"
LOCATE 31, 52: PRINT "16- MCV"
END SUB

SUB mapopenen (B$)
BESTAND$ = "SEED\" + B$
IF LEN(BESTAND$) <= 5 THEN GOTO nietopenen
OPEN BESTAND$ + ".MAP" FOR INPUT AS #2

FOR ypositie = 1 TO 62
LINE INPUT #2, regel$
FOR xpositie = 1 TO 62
type$ = MID$(regel$, xpositie, 1)
xpos = xpositie * 6 + 1
ypos = ypositie * 6
IF type$ = "!" OR type$ = "@" OR type$ = "#" OR type$ = "%" OR type$ = "^" OR type$ = "&" OR type$ = "*" OR type$ = "(" THEN
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
PSET (xpos + 1, ypos + 3), 5
PSET (xpos + 4, ypos + 2), 5
PSET (xpos + 5, ypos + 1), 5
END IF

IF type$ = "+" OR type$ = "-" THEN
'LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 6, BF

PSET (xpos + 4, ypos + 3), 14
PSET (xpos + 3, ypos + 5), 7
PSET (xpos + 1, ypos + 5), 14
PSET (xpos + 1, ypos + 3), 7
PSET (xpos + 2, ypos + 4), 14
PSET (xpos + 5, ypos + 3), 7

END IF

IF type$ = "R" OR type$ = "r" THEN
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
PSET (xpos + 1, ypos + 3), 5
PSET (xpos + 4, ypos + 2), 5
PSET (xpos + 5, ypos + 1), 5
PSET (xpos + 1, ypos + 1), 15
PSET (xpos + 3, ypos + 3), 7
PSET (xpos + 3, ypos + 1), 15
PSET (xpos + 2, ypos + 5), 7
PSET (xpos + 5, ypos + 1), 15
PSET (xpos + 4, ypos + 5), 7
PSET (xpos + 5, ypos + 1), 15

END IF

NEXT xpositie
NEXT ypositie
CLOSE #2
nietopenen:
END SUB

SUB mapsub
eenkeertjefield = 0
vanbloomaf = 0
vanfieldaf = 0

INPUT #1, deel3$                'Lees gegevens

IF LEFT$(deel3$, 5) = "Field" THEN              'Fields
DO
fieldregio:

IF eenkeertjefield = 0 THEN
fieldcell$(fields) = RIGHT$(deel3$, LEN(deel3$) - 6)
fieldcell = VAL(fieldcell$(fields))
fields = fields + 1
eenkeertjefield = 1
END IF

INPUT #1, fieldcell$(fields)            'Lees data
fieldcell = VAL(fieldcell$(fields))

IF LEFT$(fieldcell$(fields), 5) = "Bloom" THEN vanfieldaf = 1: GOTO bloomregio
IF LEFT$(fieldcell$(fields), 4) = "Seed" THEN vanfieldaf = 1: GOTO seedgevonden

 
fields = fields + 1
LOOP
END IF

IF LEFT$(deel3$, 5) = "Bloom" THEN
DO
bloomregio:

IF vanfieldaf = 0 THEN
bloomcell$(blooms) = RIGHT$(deel3$, LEN(deel3$) - 6)
bloomcell$(blooms) = bloomcell$(blooms)
bloomcell = VAL(bloomcell$(blooms))
END IF

IF vanfieldaf = 1 THEN
fieldcell$(fields) = RIGHT$(fieldcell$(fields), LEN(fieldcell$(fields)) - 6)
bloomcell$(blooms) = fieldcell$(fields)
bloomcell = VAL(bloomcell$(blooms))
blooms = blooms + 1
vanfieldaf = 0
END IF

INPUT #1, bloomcell$(blooms)
bloomcell = VAL(bloomcell$(blooms))
IF LEFT$(bloomcell$(blooms), 4) = "Seed" THEN vanbloomaf = 1: GOTO seedgevonden
blooms = blooms + 1
LOOP

END IF


IF LEFT$(deel3$, 5) = "Seed=" THEN
map$ = RIGHT$(deel3$, LEN(deel3$) - 5)
GOTO jammer
seedgevonden:

IF vanfieldaf = 1 THEN map$ = RIGHT$(fieldcell$(fields), LEN(fieldcell$(fields)) - 5)
IF vanbloomaf = 1 THEN map$ = RIGHT$(bloomcell$(blooms), LEN(bloomcell$(blooms)) - 5)
jammer:
bss$ = map$
nogeens:
LOCATE 50, 1: PRINT "Seed(MAP) number:"; map$; " found, open it ? Y/N";
INPUT "", keuze$

IF keuze$ = "Y" OR keuze$ = "y" THEN mapopenen map$: bss$ = map$: geenmapladen = 0: GOTO overslaan6

IF keuze$ = "N" OR keuze$ = "n" THEN geenmapladen = 1: EXIT SUB
IF keuze$ <> "J" AND keuze$ <> "j" AND keuze$ <> "n" AND keuze$ <> "N" THEN GOTO nogeens
overslaan6:
FOR p = 50 TO 55
LOCATE p, 1: PRINT "                                                                              "
NEXT p
gevonden = 0
EXIT SUB
END IF

IF deel3$ = "" THEN gevonden = 0: EXIT SUB

cell = VAL(deel3$)

ypositie = INT(cell / 64)
xpositie = cell - (ypositie * 64)

xpos = xpositie * 6 + 1
ypos = ypositie * 6

 

END SUB

SUB mercenarysub
INPUT #1, deel4$

IF LEFT$(deel4$, 7) = "Credits" THEN mec$ = RIGHT$(deel4$, LEN(deel4$) - 8)
IF LEFT$(deel4$, 5) = "Brain" THEN
orsp$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF orsp$ = "Human" THEN spelernr = 5: spelercr$ = mec$: quota$ = q$
END IF
IF LEFT$(deel4$, 5) = "Quota" THEN q$ = RIGHT$(deel4$, LEN(deel4$) - 6)

mercenarygeb = 1
END SUB

'
SUB nrsub (nr, kleur)
IF nr = 2 THEN kleur = 2
IF nr = 1 THEN kleur = 1
IF nr = 4 THEN kleur = 5
IF nr = 3 THEN kleur = 4
IF nr = 5 THEN kleur = 0
IF nr = 6 THEN kleur = 15
IF nr = 7 THEN kleur = 14
END SUB

SUB Ordossub
INPUT #1, deel4$

IF LEFT$(deel4$, 7) = "Credits" THEN orc$ = RIGHT$(deel4$, LEN(deel4$) - 8)
IF LEFT$(deel4$, 5) = "Brain" THEN
orsp$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF orsp$ = "Human" THEN spelernr = 2: spelercr$ = orc$: quota$ = q$
END IF
IF LEFT$(deel4$, 5) = "Quota" THEN q$ = RIGHT$(deel4$, LEN(deel4$) - 6)

ordosgeb = 1
END SUB

SUB plaatsalles
 
aantalgebouwen = gebouwen - 1
IF gebouwen > 0 THEN
FOR I = 0 TO aantalgebouwen

IF gebouwhouse$(I) = "Atreides" THEN nr = 1
IF gebouwhouse$(I) = "Ordos" THEN nr = 2
IF gebouwhouse$(I) = "Harkonnen" THEN nr = 3
IF gebouwhouse$(I) = "Sardaukar" THEN nr = 4
IF gebouwhouse$(I) = "Mercenary" THEN nr = 5
IF gebouwhouse$(I) = "Fremen" THEN nr = 6

IF gebouwsoort$(I) = "Windtrap" OR gebouwsoort$(I) = "Spice Silo" OR gebouwsoort$(I) = "Const Yard" OR gebouwsoort$(I) = "Outpost" OR gebouwsoort$(I) = "Light Fctry" OR gebouwsoort$(I) = "IX" OR gebouwsoort$(I) = "Barracks" OR gebouwsoort$(I) =  _
"WOR" THEN
nrsub nr, kleur
LINE (gebouwx(I) * 6 + 1, gebouwy(I) * 6)-(gebouwx(I) * 6 + 12 + 1, gebouwy(I) * 6 + 12), kleur, BF
IF nr <> 6 THEN LINE (gebouwx(I) * 6 + 2, gebouwy(I) * 6 + 1)-(gebouwx(I) * 6 + 12, gebouwy(I) * 6 + 11), 15, B
IF nr = 6 THEN LINE (gebouwx(I) * 6 + 2, gebouwy(I) * 6 + 1)-(gebouwx(I) * 6 + 12, gebouwy(I) * 6 + 11), 0, B
END IF

IF gebouwsoort$(I) = "Heavy Fctry" OR gebouwsoort$(I) = "Hi-Tech" OR gebouwsoort$(I) = "Repair" OR gebouwsoort$(I) = "Refinery" THEN
nrsub nr, kleur
LINE (gebouwx(I) * 6 + 1, gebouwy(I) * 6)-(gebouwx(I) * 6 + 18 + 1, gebouwy(I) * 6 + 12), kleur, BF
IF nr <> 6 THEN LINE (gebouwx(I) * 6 + 2, gebouwy(I) * 6 + 1)-(gebouwx(I) * 6 + 18, gebouwy(I) * 6 + 11), 15, B
IF nr = 6 THEN LINE (gebouwx(I) * 6 + 2, gebouwy(I) * 6 + 1)-(gebouwx(I) * 6 + 18, gebouwy(I) * 6 + 11), 0, B
END IF

IF gebouwsoort$(I) = "Palace" OR gebouwsoort$(I) = "Starport" THEN
nrsub nr, kleur
LINE (gebouwx(I) * 6 + 1, gebouwy(I) * 6)-(gebouwx(I) * 6 + 18 + 1, gebouwy(I) * 6 + 18), kleur, BF
IF nr <> 6 THEN LINE (gebouwx(I) * 6 + 2, gebouwy(I) * 6 + 1)-(gebouwx(I) * 6 + 18, gebouwy(I) * 6 + 17), 15, B
IF nr = 6 THEN LINE (gebouwx(I) * 6 + 2, gebouwy(I) * 6 + 1)-(gebouwx(I) * 6 + 18, gebouwy(I) * 6 + 17), 0, B
END IF

IF gebouwsoort$(I) = "R-Turret" OR gebouwsoort$(I) = "Turret" THEN
nr = 7
nrsub nr, kleur
LINE (gebouwx(I) * 6 + 1, gebouwy(I) * 6)-(gebouwx(I) * 6 + 6 + 1, gebouwy(I) * 6 + 6), kleur, BF
END IF
CIRCLE (gebouwx(I) * 6 + 3.5, gebouwy(I) * 6 + 2.5), 2.5, 14
NEXT I
END IF

fieldlaatst = fields - 1
FOR I = 0 TO fieldlaatst

cell = VAL(fieldcell$(I))
cuy = INT(cell / 64)
cux = cell - (cuy * 64)

xpos = cux * 6 + 1
ypos = cuy * 6
LINE (xpos, ypos)-(xpos + 12, ypos + 12), 8, BF
LINE (xpos + 1, ypos + 1)-(xpos + 11, ypos + 11), 7, B
NEXT I

bloomlaatst = blooms - 1
FOR I = 0 TO bloomlaatst

cell = VAL(bloomcell$(I))
cuy = INT(cell / 64)
cux = cell - (cuy * 64)

xpos = cux * 6 + 1
ypos = cuy * 6
LINE (xpos, ypos)-(xpos + 6, ypos + 6), 4, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 14, B
NEXT I

aantalgens = gens - 1
FOR I = 0 TO aantalgens
cell = VAL(gencell$(I))
cuy = INT(cell / 64)
cux = cell - (cuy * 64)

xpos = cux * 6 + 1
ypos = cuy * 6
IF gensoort$(I) = "Wall" THEN
'LINE (xpos, ypos)-(xpos + 6, ypos + 6), 7, BF
'LINE (xpos, ypos)-(xpos + 3, ypos + 6), 0
'LINE (xpos + 6, ypos)-(xpos + 3, ypos + 6), 0
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos), 15, BF
LINE (xpos + 1, ypos + 1)-(xpos + 1, ypos + 5), 15, BF
LINE (xpos + 5, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
LINE (xpos + 5, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
END IF

IF gensoort$(I) = "Concrete" THEN
'LINE (xpos, ypos)-(xpos + 6, ypos + 6), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 5), 8, BF
LINE (xpos + 1, ypos + 1)-(xpos + 5, ypos + 1), 7, BF
LINE (xpos + 1, ypos + 1)-(xpos + 1, ypos + 5), 7, BF
END IF
NEXT I

aantalunits = units - 1
IF units > 0 THEN
FOR I = 0 TO aantalunits
IF unithouse$(I) = "Fremen" THEN kleur = 15
IF unithouse$(I) = "Ordos" THEN kleur = 2
IF unithouse$(I) = "Atreides" THEN kleur = 1
IF unithouse$(I) = "Sardaukar" THEN kleur = 5
IF unithouse$(I) = "Harkonnen" THEN kleur = 4
IF unithouse$(I) = "Mercenary" THEN kleur = 0
LINE (unitx(I) * 6 + 1, unity(I) * 6)-(unitx(I) * 6 + 6 + 1, unity(I) * 6 + 6), kleur, BF
NEXT I
END IF


END SUB

SUB reinfsub
LINE INPUT #1, reinfregel$(reinregels)

IF LEN(reinfregel$(reinregels)) < 1 THEN gevonden = 0: EXIT SUB

reinregels = reinregels + 1
reingeladen = 1
reinfkeer = 0
reinfnr = reinfnr + 1
END SUB

SUB Sardaukarsub
INPUT #1, deel4$

IF LEFT$(deel4$, 7) = "Credits" THEN sac$ = RIGHT$(deel4$, LEN(deel4$) - 8)
IF LEFT$(deel4$, 5) = "Brain" THEN
orsp$ = RIGHT$(deel4$, LEN(deel4$) - 6)
IF orsp$ = "Human" THEN spelernr = 4: spelercr$ = sac$: quota$ = q$
END IF
IF LEFT$(deel4$, 5) = "Quota" THEN q$ = RIGHT$(deel4$, LEN(deel4$) - 6)
sardaukargeb = 1
END SUB

SUB scherm
'Het scherm...
 
LINE (387, 0)-(387, 387), 7
LINE (388, 0)-(388, 388), 15
LINE (389, 0)-(389, 389), 8
LINE (0, 387)-(387, 387), 7
LINE (0, 388)-(388, 388), 15
LINE (0, 389)-(389, 389), 8
 
LINE (1, 1)-(384, 384), 6, BF

FOR x = 0 TO 384 STEP 6
LINE (x + 1, 0)-(x + 1, 384), 0
LINE (0, x)-(384, x), 0
NEXT x

LOCATE 50, 1: PRINT "                                  "
zettoetsen
verren = 1
END SUB

'
SUB tekenschaal
IF schaal = 0 THEN
psx1 = 1 * 6 + 2
psy1 = 1 * 6 + 1
psy2 = psy1 + 62 * 6 - 2
psx2 = psx1 + 62 * 6 - 3
LINE (psx1, psy1)-(psx2, psy2), 14, B
END IF

IF schaal = 1 THEN
psx1 = 16 * 6 + 2
psy1 = 16 * 6 + 1
psy2 = psy1 + 32 * 6 - 2
psx2 = psx1 + 32 * 6 - 3
LINE (psx1, psy1)-(psx2, psy2), 14, B
END IF
END SUB

SUB toetsen
LINE (100, 100)-(540, 350), 0, BF
LINE (100, 100)-(540, 350), 7, B
LINE (103, 103)-(537, 347), 7, B
LOCATE 15, 15: PRINT "DunEdit Version 1.24 HELP"
COLOR 15: LOCATE 17, 15: PRINT "Short Keys:": COLOR 7
LOCATE 19, 15: PRINT "- F1 This HELP"
LOCATE 20, 15: PRINT "- F2 Quick Save"
LOCATE 21, 15: PRINT "- F3 Load Scenario"
COLOR 15: LOCATE 23, 15: PRINT "Cursor Keys:": COLOR 7
LOCATE 25, 15: PRINT "Arrows for moving cursor or num pad."
COLOR 15: LOCATE 27, 15: PRINT "Dunedit place Keys:": COLOR 7
LOCATE 29, 15: PRINT "- B     Place Spice Bloom"
LOCATE 30, 15: PRINT "- C     Set CHOAM controls"
LOCATE 31, 15: PRINT "- F     Place Spice Field"
LOCATE 32, 15: PRINT "- T     Place StartScreen"
LOCATE 33, 15: PRINT "- Space Place UNIT/STRUCTURE"
LOCATE 34, 15: PRINT "- M     Menu"
LOCATE 35, 15: PRINT "- W     Place WALL"
LOCATE 36, 15: PRINT "- S     Place Concrete"
LOCATE 37, 15: PRINT "- A     Change default Action"
LOCATE 38, 15: PRINT "- H     Change default House"
LOCATE 39, 15: PRINT "- O     Options"
LOCATE 40, 15: PRINT "Press A Key!"
WHILE INKEY$ = "": WEND
CLS
scherm                  'Draw Interface!
zettoetsen              'Draw Interface!!!
IF geenmapladen = 0 THEN mapopenen bss$
plaatsalles             'place all things that have to be placed.
tekenschaal
lijnen
END SUB

'
SUB unitssub
 
INPUT #1, deel2$
IF LEFT$(deel2$, 2) <> "ID" THEN gevonden = 0: EXIT SUB

INPUT #1, soort$, p, cellu$(units), r$, actie$(units)

IF units < 10 AND units > -1 THEN

L$ = STR$(units)
L$ = RIGHT$(L$, LEN(L$) - 1)
num$(units) = "00" + L$
END IF

IF units < 100 AND units > 9 THEN
L$ = STR$(units)
L$ = RIGHT$(L$, LEN(L$) - 1)
num$(units) = "0" + L$
END IF

IF units < 1000 AND units > 99 THEN
L$ = STR$(units)
L$ = RIGHT$(L$, LEN(L$) - 1)
num$(units) = "" + L$
END IF


cell = VAL(cellu$(units))

ypositie = INT(cell / 64)
xpositie = cell - (ypositie * 64)

unitx(units) = xpositie
unity(units) = ypositie
unitsoort$(units) = soort$

deel2$ = RIGHT$(deel2$, LEN(deel2$) - 6)

unithouse$(units) = deel2$
IF deel2$ = "Fremen" THEN kleur = 15                    'FREMEN
IF deel2$ = "Ordos" THEN kleur = 2                     'Groen
IF deel2$ = "Atreides" THEN kleur = 1                   'Blauw
IF deel2$ = "Sardaukar" THEN kleur = 5                  'Paars
IF deel2$ = "Harkonnen" THEN kleur = 4                  'Rood

xpositie = xpositie * 6 + 1
ypositie = ypositie * 6
LINE (xpositie, ypositie)-(xpositie + 6, ypositie + 6), kleur, BF

units = units + 1

  
END SUB

'
SUB wisblokje (x, y)
LINE (x, y)-(x + 6, y + 6), 0, B
END SUB

SUB wiszijkant
'LINE (390, 69)-(700, 400), 15, B
LINE (390, 69)-(700, 400), 0, BF
'WHILE INKEY$ = "": WEND



END SUB

SUB zettoetsen
LOCATE 54, 1: COLOR 14: PRINT "F1"; : COLOR 7: PRINT "-Show all keys"
LOCATE 56, 65: COLOR 9: PRINT "Version 1.24"
END SUB

